log.info("[Infinite Consumables] started loading")

local runInMultiplayer = false;

local infiniteCoatings = true;
local infiniteAmmo = true;
local infiniteItems = false;

local IC_debug = false;

function IC_logDebug(argStr)
	if IC_debug then
		log.info("[Infinite Consumables] "..tostring(argStr));
	end
end

sdk.hook(sdk.find_type_definition("snow.data.bulletSlider.BottleSliderFunc"):get_method("consumeItem"),
function(args)
	local LobbyManager = sdk.get_managed_singleton("snow.LobbyManager");
	local isOnline = LobbyManager:call("isInInternetQuestSession");
	IC_logDebug(tostring(isOnline)..":"..tostring(runInMultiplayer)..":"..tostring(infiniteCoatings));
	if (not isOnline or runInMultiplayer) and infiniteCoatings then
		return sdk.PreHookResult.SKIP_ORIGINAL
	end
end,
function(retval)
	return retval;
end
);

sdk.hook(sdk.find_type_definition("snow.data.bulletSlider.BulletSliderFunc"):get_method("consumeItem"),
function(args)
	local LobbyManager = sdk.get_managed_singleton("snow.LobbyManager");
	local isOnline = LobbyManager:call("isInInternetQuestSession");
	IC_logDebug(tostring(isOnline)..":"..tostring(runInMultiplayer)..":"..tostring(infiniteAmmo));
	if (not isOnline or runInMultiplayer) and infiniteAmmo then
		return sdk.PreHookResult.SKIP_ORIGINAL
	end
end,
function(retval)
	return retval;
end
);

sdk.hook(sdk.find_type_definition("snow.data.ItemSlider"):get_method("notifyConsumeItem"),
function(args)
	local LobbyManager = sdk.get_managed_singleton("snow.LobbyManager");
	local isOnline = LobbyManager:call("isInInternetQuestSession");
	IC_logDebug(tostring(isOnline)..":"..tostring(runInMultiplayer)..":"..tostring(infiniteItems));
	if (not isOnline or runInMultiplayer) and infiniteItems then
		return sdk.PreHookResult.SKIP_ORIGINAL
	end
end,
function(retval)
	return retval;
end
);